﻿@using System.Security.Claims
@{
    ViewData["Title"] = "Compliance Queue";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
    string EncryptedGuid = ViewBag.EncryptedGuid;
    bool hasRIA = ViewBag.hasRIA;
    var TimeZone = User.Claims.FirstOrDefault(c => c.Type == "TimeZone")?.Value;
}
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1">
                        <h3 class="card-label text-primary">
                            Compliance Queue
                        </h3>
                    </div>
                    <div class="align-self-center">
                        <div class="dropdown mr-10">
                            @if (!hasRIA)
                            {
                                <span class="fa-stack pulse pulse-warning" data-toggle="tooltip" data-html="true" data-original-title="Please select RIA" data-placement="right" role="button">
                                    <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                    <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                    <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                </span>
                            }
                            <button class="btn btn-sm font-size-h6 font-weight-bold btn-maroon dropdown-toggle @(!hasRIA ? "disabled" :"")" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Report
                            </button>
                            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                <a class="dropdown-item" href="/firm/adv-2b?token=@EncryptedGuid&tz=@TimeZone" target="_blank">Firm ADV 2B</a>
                            </div>
                        </div>
                    </div>
                    <div class="align-self-center">
                        <button class="btn btn-primary btn-sm btn-upload-document font-weight-bold font-size-h6 btn-add"><i class="fas fa-upload"></i>Upload</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="datatable datatable-bordered datatable-sticky" id="compliance_documents"></div>
        </div>
    </div>
</div>
<div class="modal" id="ComplianceDocumentUploadModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<script src="~/js/page/compliance-documents.js" asp-append-version="true"></script>
@section scripts{
    <script>
        localStorage.setItem("adviserLastPageHref", '@area/compliance-documents');
        $(document).on("click", ".btn-upload-document", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`adviser/home/compliancedocumentmodal?guid=${guid}`, "ComplianceDocumentUploadModal", null, function () {
                KTApp.unblockPage();
                $("#ComplianceDocumentUploadModal").modal({ backdrop: 'static' });
                autosize($('textarea'));
            });
        });
        var ktDataTablOptions = ktDataTableDefaultConfigOptions;
        ktDataTablOptions.source = `adviser/home/fetchcompliancedocuments`;
        var datatable = $('#compliance_documents').KTDatatable({
            columnFilter: true,
            data: ktDataTablOptions,
            columns: [
                { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                {
                    field: 'fileName', title: 'File Name/Url', width: 250, filter: {},
                    template: function (row) {
                        var migratedHtml = row.isFromV1 ? '<span class="label label-inline label-info font-weight-bold ml-2">Migrated</span>' : '';
                        var warningHtml = row.status == ComplianceDocumentStatus.Approved.Value && row.reqiuredChange ?
                            `<span class="fa-stack pulse pulse-warning" data-toggle="tooltip" data-html="true" data-original-title="Please check compliance note" data-placement="right" role="button">
                                                     <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                     <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                     <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                 </span>` : '';
                        var html = `<div class="d-flex flex-row">
                                                          <div>${row.fileName}${migratedHtml}</div>
                                                          ${warningHtml}
                                                        </div>`
                        return html;
                    }
                },
                {
                    field: 'extension', title: 'File Type', sortable: false, textAlign: 'center', width: 120, filter: { filterType: "select", container: "fileType", size: 5 },
                    template: function (row) {
                        var extension = row.extension ? row.extension : "";
                        row.fileName = row.fileName.replace("'", "/");
                        var type = extension.includes("doc") ? "word" : extension.includes("xls") ? "excel" : extension.includes("csv") ? "csv" : extension.includes("ppt") ? "powerpoint" : extension.includes("pdf") ? "pdf" : row.contentType.includes("image") ? "image" : row.contentType.includes("audio") ? "audio" : row.contentType.includes("video") ? "video" : row.contentType.includes("text") ? "alt" : row.contentType.includes("link") ? "globe" : "";
                        var color = extension.includes("doc") ? "295497" : extension.includes("xls") || extension.includes("csv") ? "1f7244" : extension.includes("ppt") ? "d14424" : extension.includes("pdf") ? "cb0606" : row.contentType.includes("image") ? "26b99a" : row.contentType.includes("audio") ? "8950FC" : row.contentType.includes("video") ? "F64E60" : row.contentType.includes("text") ? "3699FF" : row.contentType.includes("link") ? "0073e9" : "008080";
                        var knownHtml = `<i class="fas fa${row.fileSize > 0 ? "-file" : ""}${type.length > 0 ? "-" : ""}${type}" style=color:#${color};font-size:${row.fileSize > 0 ? "30" : "25"}px;" data-toggle="tooltip" data-title="${row.fileSize > 0 ? extension.toUpperCase() : "Click here to view"}" id="icon-${row.id}"></i>`;
                        var unknownHtml = `<span class="fa-stack fa-1x" style="font-size:1.2em !important" data-toggle="tooltip" data-title="${extension.toUpperCase()}" id="icon-${row.id}">
                                                                       <i class="fa fa-file fa-stack-2x" style="color:#${color}"></i>
                                                                         <span class="fa fa-stack-1x">
                                                                             <span style="font-size:10px;color:white;font-family: 'Poppins';font-weight: normal;">
                                                                                 ${extension.toUpperCase()}
                                                                             </span>
                                                                       </span>
                                                                   </span>	`;
                        var fun = row.fileSize > 0 ? `clientFileDownload('documents/compliance', '${row.fileName}', '${row.versionId}',${row.id})` : `openFileOrLinkNewWindow('${row.fileName}')`;
                        return `<a href="javascript:" onclick="${fun}">
                                                                                                                                                                                                                    ${type.length > 0 ? knownHtml : unknownHtml}
                                                                                                                                                                                                                    <i class="fas fa-arrow-down animated faa-falling ml-2 text-primary d-none" id="loader-${row.id}"></i>
                                                                                                                                                                                                                </a>`;
                    }
                },
                {
                    field: 'fileSize', title: 'File Size', width: 60,
                    template: function (row) {
                        return row.fileSize > 0 ? `${humanFileSize(row.fileSize)}` : "-";
                    }
                },
                {
                    field: 'uploadedDate', title: 'Uploaded Date', sortable: 'desc', width: 120,
                    template: function (row) {
                        return getDataTableDateWithHtml(row.uploadedDate)
                    },
                },
                {
                    field: 'status', title: 'Status', sortable: false, width: 140, filter: { filterType: "select" },
                    template: function (row) {
                        var status = row.status == ComplianceDocumentStatus.Pending.Value ? "Pending" : row.status == ComplianceDocumentStatus.Approved.Value ? "Approved" : "Rejected";
                        var color = row.status == ComplianceDocumentStatus.Pending.Value ? "warning" : row.status == ComplianceDocumentStatus.Approved.Value ? "success" : "danger";
                        var reUploadHtml = row.status == ComplianceDocumentStatus.Rejected.Value ? `<span data-toggle="tooltip" data-original-title="Click here to Re-upload" role="button" class="btn-upload-document" data-guid="${row.guid}"><i class="fas fa-upload text-primary icon-md"></i>
                                                                                                                                                                                                                                                                                        </span>`: "";
                        return `<span class="label font-weight-bold label-lg  label-${color} label-inline mr-2">${status}</span>${reUploadHtml}`
                    },
                },
                {
                    field: 'adviserNote', title: 'Adviser Note', width: 150, sortable: false,
                    template: function (row) {
                        var str = row.adviserNote != null ? row.adviserNote.substring(0, 30) : "";
                        var readMoreHtml = row.adviserNote != null && row.adviserNote.length != str.length ? `...</br><a href='javascript:' data-toggle='popover' data-html="true" data-title='Adviser Note' data-content="${row.adviserNote}" role="button">Read more</a>` : "";
                        return row.adviserNote != null ? `${str}${readMoreHtml}` : "<div style='text-align:center'>-</div>"
                    },
                },
                {
                    field: 'reviewedBy.userData.name', title: 'Reviewed By', width: 200, filter: { filterType: "select", additionalClasses: "select2", container: "reviewedById" },
                    template: function (row) {
                        return row.reviewedBy != null ? row.reviewedBy.userData.name : "<div style='text-align:center'>-</div>"
                    },
                },
                {
                    field: 'complianceNote', title: 'Compliance Note', width: 150, sortable: false,
                    template: function (row) {
                        var str = row.complianceNote != null ? row.complianceNote.substring(0, 30) : "";
                        var readMoreHtml = row.complianceNote != null && row.complianceNote.length != str.length ? `...</br><a href='javascript:' data-toggle='popover' data-html="true" data-title='Compliance Note' data-content="${row.complianceNote}" role="button">Read more</a>` : "";
                        return row.complianceNote != null ? `${str}${readMoreHtml}` : "<div style='text-align:center'>-</div>"
                    },
                },
                {
                    field: 'reviewedDate', title: 'Reviewed Date', width: 130,
                    template: function (row) {
                        return getDataTableDateWithHtml(row.reviewedDate)
                    },
                },
            ],
        })
        $('#compliance_documents').on('datatable-on-init', function (e, data) {
            bindComplianceDocumentStatusDropdown();
            bindfileTypeDropdown();
            bindComplianceDropdown();
        });
    </script>
}